#ifndef KNOCKBACK_COMPONENT_H_
#define KNOCKBACK_COMPONENT_H_

#include "../backend/CBSEBackend.h"
#include "../backend/CBSEComponents.h"

class KnockbackComponent: public KnockbackComponentBase {

	public:
		// ///////////////////// //
		// Autogenerated Members //
		// ///////////////////// //

		/**
		 * @brief Default constructor of the KnockbackComponent.
		 * @param entity The entity that owns the component instance.
		 * @note This method is an interface for autogenerated code, do not modify its signature.
		 */
		KnockbackComponent(Entity& entity);

		/**
		 * @brief Handle the Damage message.
		 * @param amount
		 * @param source
		 * @param location
		 * @param direction
		 * @param flags
		 * @param meansOfDeath
		 * @note This method is an interface for autogenerated code, do not modify its signature.
		 */
		void HandleDamage(float amount, gentity_t* source, Util::optional<Vec3> location, Util::optional<Vec3> direction, int flags, meansOfDeath_t meansOfDeath);

		// ///////////////////// //

		constexpr static float DAMAGE_TO_KNOCKBACK   = 5.0f;
		constexpr static float KNOCKBACK_MIN_MASSMOD = 0.5f;
		constexpr static float KNOCKBACK_MAX_MASSMOD = 2.0f;
		constexpr static float KNOCKBACK_NORMAL_MASS = 100.0f;
		constexpr static int   KNOCKBACK_PMOVE_TIME  = 50;

	private:

};

#endif // KNOCKBACK_COMPONENT_H_

